--sample thanks to Tim 
IF OBJECT_ID('SalesHistory')>0 
DROP TABLE SalesHistory;
GO
CREATE TABLE [dbo].[SalesHistory]
( 
[SaleID] [int] IDENTITY(1,1) NOT NULL PRIMARY KEY, 
[Product] [varchar](10) NULL, 
[SaleDate] [datetime] NULL, 
[SalePrice] [money] NULL
)
GO

CREATE TYPE SalesHistoryTableType AS TABLE
( 
[Product] [varchar](10) NULL, 
[SaleDate] [datetime] NULL, 
[SalePrice] [money] NULL
)
GO

--to view them
SELECT * FROM sys.table_types


CREATE PROCEDURE usp_InsertBigScreenProducts
(
@TableVariable SalesHistoryTableType READONLY
)
AS
BEGIN
INSERT INTO SalesHistory
(
Product, SaleDate, SalePrice
)
SELECT
Product, SaleDate, SalePrice
FROM
@TableVariable
WHERE
Product = 'BigScreen' 

END
GO



DECLARE @DataTable AS SalesHistoryTableType

--add 1,000 rows into the @DataTable table variable: 

DECLARE @i SMALLINT
SET @i = 1 

WHILE (@i <=1000)
BEGIN 

INSERT INTO @DataTable(Product, SaleDate, SalePrice) 
VALUES ('Computer', DATEADD(mm, @i, '3/11/1919'), DATEPART(ms, GETDATE()) + (@i + 57)) 

INSERT INTO @DataTable(Product, SaleDate, SalePrice) 
VALUES('BigScreen', DATEADD(mm, @i, '3/11/1927'), DATEPART(ms, GETDATE()) + (@i + 13)) 

INSERT INTO @DataTable(Product, SaleDate, SalePrice) 
VALUES('PoolTable', DATEADD(mm, @i, '3/11/1908'), DATEPART(ms, GETDATE()) + (@i + 29)) 

SET @i = @i + 1
END

EXECUTE usp_InsertBigScreenProducts
@TableVariable = @DataTable

SELECT * FROM SalesHistory